       IDENTIFICATION DIVISION.
       PROGRAM-ID.    CBLALTC3.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      *           This program was generated by SimoZAPS              *
      *             A product of SimoTime Technologies                *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      *  Generation Date: 2005-06-23  Generation Time: 19:40:56:69    *
      *                                                               *
      *                                   Record    Record     Key    *
      *  Function  Name     Organization  Format    Max-Min  Pos-Len  *
      *  INPUT     ALTKSD   INDEXED       VARIABLE   00512    00001   *
      *                                                       00012   *
      *                                                               *
      * Based upon a parameter received from JCL this program will    *
      * read the VSAM, KSDS and produce a report in customer-number   *
      * (i.e. primary key) or telephone-number (i.e. alternate index) *
      * sequence.                                                     *
      *                                                               *
      *****************************************************************
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
      *
      *    When processing using the Primary Index the following two
      *    DD statements are required in the JCL member.
      *
      *    //ALTKSD   DD  DSN=SIMOTIME.DATA.ALTKSD,DISP=SHR
      *    //ALTKSD1  DD  DSN=SIMOTIME.DATA.ALTKSD.PATH,DISP=SHR
      *
      *    The first DD statement points to the VSAM cluster and the
      *    second DD statement causes the alternate index within the
      *    cluster to be available when processing.
      *
      *    This program uses the parameter passed from JCL to
      *    determine the sequence of processing records within the
      *    data set. If the parameter is "AIX1" then the START
      *    statement is used to position the read to start at the
      *    first entry in the alternate index. The following shows
      *    the JCL statement for passing the parameter.
      *
      *    //LISTKSD  EXEC PGM=CBLALTC3,PARM=AIX1
      *
           SELECT ALTKSD-FILE ASSIGN TO       ALTKSD
                  ORGANIZATION  IS INDEXED
                  ACCESS MODE   IS SEQUENTIAL
                  RECORD KEY    IS ALTKSD-KEY-01
                  ALTERNATE
                  RECORD KEY    IS ALTKSD-KEY-02 WITH DUPLICATES
                  FILE STATUS   IS ALTKSD-STATUS.
           SELECT PRINT-FILE    ASSIGN TO       REPORT03.

      *****************************************************************
       DATA DIVISION.
       FILE SECTION.
       FD  ALTKSD-FILE
           DATA RECORD    IS ALTKSD-REC
           .
       01  ALTKSD-REC.
           05  ALTKSD-KEY-01  PIC X(12).
           05  ALTKSD-DATA-01 PIC X(56).
           05  ALTKSD-KEY-02  PIC X(12).
           05  ALTKSD-DATA-02 PIC X(432).

       FD  PRINT-FILE.
       01  PRINT-LINE           PIC X(132).

      *****************************************************************
      * This program was created using the SYSMASK3.TXT file as the   *
      * template for the File I/O. It is intended for use with the    *
      * TransCALL facility that makes a call to a routine that does   *
      * the actual conversion between EBCDIC and ASCII. For more      *
      * information or questions contact SimoTime Technologies.       *
      *                                                               *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      * The SYSMASK3 provides for the sequential reading of the input *
      * file and the sequential writing of the output file.           *
      * If the output file is indexed then the input file must be in  *
      * sequence by the field that will be used to provide the key    *
      * for the output file.                                          *
      *                                                               *
      * If the key field is not in sequence then refer to SYSMASK4    *
      * to provide for a random add or update of the indexed file.    *
      *****************************************************************
       WORKING-STORAGE SECTION.
       01  SIM-TITLE.
           05  T1 pic X(11) value '* CBLALTC3 '.
           05  T2 pic X(34) value 'Read KSDS by Primary or Alternate '.
           05  T3 pic X(10) value 'v05.06.08 '.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* CBLALTC3 '.
           05  C2 pic X(20) value 'Copyright 1987-2019 '.
           05  C3 pic X(28) value '    SimoTime Technologies   '.
           05  C4 pic X(20) value ' All Rights Reserved'.

       01  SIM-THANKS-01.
           05  C1 pic X(11) value '* CBLALTC3 '.
           05  C2 pic X(32) value 'Thank you for using this program'.
           05  C3 pic X(32) value ' provided from SimoTime Technolo'.
           05  C4 pic X(04) value 'gies'.

       01  SIM-THANKS-02.
           05  C1 pic X(11) value '* CBLALTC3 '.
           05  C2 pic X(32) value 'Please send all inquires or sugg'.
           05  C3 pic X(32) value 'estions to the helpdesk@simotime'.
           05  C4 pic X(04) value '.com'.

       01  ALTKSD-STATUS.
           05  ALTKSD-STATUS-L     pic X.
           05  ALTKSD-STATUS-R     pic X.
       01  ALTKSD-EOF              pic X       value 'N'.
       01  ALTKSD-OPEN-FLAG        pic X       value 'C'.

      *****************************************************************
      * The following buffers are used to create a four-byte status   *
      * code that may be displayed.                                   *
      *****************************************************************
       01  IO-STATUS.
           05  IO-STAT1            pic X.
           05  IO-STAT2            pic X.
       01  IO-STATUS-04.
           05  IO-STATUS-0401      pic 9     value 0.
           05  IO-STATUS-0403      pic 999   value 0.
       01  TWO-BYTES-BINARY        pic 9(4)  BINARY.
       01  TWO-BYTES-ALPHA         redefines TWO-BYTES-BINARY.
           05  TWO-BYTES-LEFT      pic X.
           05  TWO-BYTES-RIGHT     pic X.

      *****************************************************************
      * Message Buffer used by the Z-DISPLAY-MESSAGE-TEXT routine.    *
      *****************************************************************
       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(11)   value '* CBLALTC3 '.
           05  MESSAGE-TEXT.
               10  MESSAGE-TEXT-1  pic X(68)   value SPACES.
               10  MESSAGE-TEXT-2  pic X(188)  value SPACES.

      *****************************************************************
       01  PROGRAM-NAME            pic X(8)     value 'CBLALTC3'.

       01  HEADER-LINE.
           05  filler              pic X(10)   value '....:....1'.
           05  filler              pic X(10)   value '....:....2'.
           05  filler              pic X(10)   value '....:....3'.
           05  filler              pic X(10)   value '....:....4'.
           05  filler              pic X(10)   value '....:....5'.
           05  filler              pic X(10)   value '....:....6'.
           05  filler              pic X(10)   value '....:....7'.
           05  filler              pic X(10)   value '....:....8'.

       01  APPL-RESULT             pic S9(9)    comp.
           88  APPL-AOK            value 0.
           88  APPL-EOF            value 16.
       01  ALTKSD-TOTAL.
           05  ALTKSD-CTR  pic 9(9)    value 0.
           05  filler      pic X(3)    value ' - '.
           05  filler      pic X(23)   value 'Line count for ALTKSD'.

      *****************************************************************
       LINKAGE SECTION.
       01  PARM-PASS-AREA.
           05  PARM-LEN                PIC  9(04) COMP.
           05  PARM-DATA.
               10  PARM-DATA-BYTE      PIC  X(01) OCCURS  0 TO 100
                                                  DEPENDING ON PARM-LEN.

      *****************************************************************
       PROCEDURE DIVISION using PARM-PASS-AREA.
           perform Z-POST-COPYRIGHT
           OPEN OUTPUT PRINT-FILE
           perform ALTKSD-OPEN
           move all LOW-VALUES to ALTKSD-REC
           if  PARM-LEN > 0 and < 5
               evaluate PARM-DATA
                 when 'AIX1' perform SETUP-AIX1-PROCESS
                 when 'PIX0' perform SETUP-PIX0-PROCESS
                 when other  perform SETUP-INVALID-PROCESS
               end-evaluate
           else
               move 'Assume Primary Index Processing' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if

           perform PRINT-HEADER

           perform until ALTKSD-STATUS > '02'
               perform ALTKSD-READ
               if  ALTKSD-STATUS = '00'
               or  ALTKSD-STATUS = '02'
                   add 1 to ALTKSD-CTR
                   WRITE PRINT-LINE FROM ALTKSD-REC
                   AFTER ADVANCING 1  LINE
               end-if
           end-perform

           move ALTKSD-TOTAL to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT

           if  APPL-EOF
               move 'is Complete...' to MESSAGE-TEXT
           else
               move 'is ABENDING...' to MESSAGE-TEXT
           end-if
           perform Z-DISPLAY-MESSAGE-TEXT

           perform PRINT-FOOTER

           perform ALTKSD-CLOSE
           CLOSE PRINT-FILE

           perform Z-THANK-YOU

           GOBACK.

      *****************************************************************
       PRINT-HEADER.
           move SPACES TO PRINT-LINE.
           write PRINT-LINE after advancing page

           move SIM-TITLE TO PRINT-LINE.
           write PRINT-LINE after advancing page

           move SIM-COPYRIGHT TO PRINT-LINE.
           write PRINT-LINE after advancing page

           move HEADER-LINE TO PRINT-LINE.
           write PRINT-LINE after advancing page
           exit.

      *****************************************************************
       PRINT-FOOTER.

           move SPACES TO PRINT-LINE.
           write PRINT-LINE after advancing page

           move SIM-THANKS-01 TO PRINT-LINE.
           write PRINT-LINE after advancing page

           move SIM-THANKS-02 TO PRINT-LINE.
           write PRINT-LINE after advancing page
           exit.

      *****************************************************************
       SETUP-AIX1-PROCESS.
           start ALTKSD-FILE key greater ALTKSD-KEY-02
           if  ALTKSD-STATUS = '00'
               move 'Process by alternate index' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
           else
               move 'Error starting alternate index' to MESSAGE-TEXT
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
       SETUP-PIX0-PROCESS.
           move 'Process by primary index' to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT
           exit.

      *****************************************************************
       SETUP-INVALID-PROCESS.
           move 'Invalid Parameter for index usage' to MESSAGE-TEXT
           perform Z-ABEND-PROGRAM
           exit.

      *****************************************************************
      * I/O Routines for the INPUT File...                            *
      *****************************************************************
       ALTKSD-READ.
           if  ALTKSD-OPEN-FLAG = 'C'
               perform ALTKSD-OPEN
           end-if
           read ALTKSD-FILE
           if  ALTKSD-STATUS = '00'
           or  ALTKSD-STATUS = '02'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  ALTKSD-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if.
           if  APPL-AOK
           or  APPL-EOF
               CONTINUE
           else
               move 'READ Failure with ALTKSD' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move ALTKSD-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       ALTKSD-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open INPUT ALTKSD-FILE
           if  ALTKSD-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to ALTKSD-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'OPEN Failure with ALTKSD' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move ALTKSD-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       ALTKSD-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close ALTKSD-FILE
           if  ALTKSD-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'C' to ALTKSD-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CLOSE Failure with ALTKSD' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move ALTKSD-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * The following Z-ROUTINES provide administrative functions     *
      * for this program.                                             *
      *****************************************************************
      * ABEND the program, post a message to the console and issue    *
      * a STOP RUN.                                                   *
      *****************************************************************
       Z-ABEND-PROGRAM.
           if  MESSAGE-TEXT not = SPACES
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           move 'PROGRAM-IS-ABENDING...'  to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT
           add 12 to ZERO giving RETURN-CODE
           STOP RUN.
      *    exit.

      *****************************************************************
      * Display CONSOLE messages...                                   *
      *****************************************************************
       Z-DISPLAY-MESSAGE-TEXT.
           if MESSAGE-TEXT-2 = SPACES
               display MESSAGE-BUFFER(1:79)
           else
               display MESSAGE-BUFFER
           end-if
           move all SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
      * Display the file status bytes. This routine will display as   *
      * four digits. If the full two byte file status is numeric it   *
      * will display as 00nn. If the 1st byte is a numeric nine (9)   *
      * the second byte will be treated as a binary number and will   *
      * display as 9nnn.                                              *
      *****************************************************************
       Z-DISPLAY-IO-STATUS.
           if  IO-STATUS not NUMERIC
           or  IO-STAT1 = '9'
               move IO-STAT1 to IO-STATUS-04(1:1)
               subtract TWO-BYTES-BINARY from TWO-BYTES-BINARY
               move IO-STAT2 to TWO-BYTES-RIGHT
               add TWO-BYTES-BINARY to ZERO giving IO-STATUS-0403
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STATUS-04 to MESSAGE-TEXT(17:4)
               perform Z-DISPLAY-MESSAGE-TEXT
           else
               move '0000' to IO-STATUS-04
               move IO-STATUS to IO-STATUS-04(3:2)
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STATUS-04 to MESSAGE-TEXT(17:4)
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           exit.

      *****************************************************************
       Z-POST-COPYRIGHT.
           display SIM-TITLE     upon console
           display SIM-COPYRIGHT upon console
           exit.

      *****************************************************************
       Z-THANK-YOU.
           display SIM-THANKS-01 upon console
           display SIM-THANKS-02 upon console
           exit.
      *****************************************************************
      *           This program was generated by SimoZAPS              *
      *             A product of SimoTime Technologies                *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      *  Generation Date: 2005-06-23  Generation Time: 19:40:56:70    *
      *****************************************************************
