       IDENTIFICATION DIVISION.
       PROGRAM-ID.    CBLALTC9.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      *           This program was generated by SimoZAPS              *
      *             A product of SimoTime Technologies                *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      *  Generation Date: 2005-06-29  Generation Time: 22:51:28:17    *
      *                                                               *
      *                                   Record    Record     Key    *
      *  Function  Name     Organization  Format    Max-Min  Pos-Len  *
      *  INPUT     ALTQSMD2 SEQUENTIAL    FIXED      00080            *
      *                                                               *
      *  OUTPUT    ALTKSD   INDEXED       VARIABLE   00512    00001   *
      *                                                       00012   *
      *                                                               *
      *****************************************************************
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT ALTQSMD2-FILE  ASSIGN TO       ALTQSMD2
                  ORGANIZATION  IS SEQUENTIAL
                  ACCESS MODE   IS SEQUENTIAL
                  FILE STATUS   IS ALTQSMD2-STATUS.
           SELECT ALTKSD-FILE  ASSIGN TO       ALTKSD
                  ORGANIZATION  IS INDEXED
                  ACCESS MODE   IS SEQUENTIAL
                  RECORD KEY    IS ALTKSD-KEY-01
                  FILE STATUS   IS ALTKSD-STATUS.

      *****************************************************************
       DATA DIVISION.
       FILE SECTION.
       FD  ALTQSMD2-FILE
           DATA RECORD    IS ALTQSMD2-REC
           .
       01  ALTQSMD2-REC.
           05  ALTQSMD2-DATA-01 PIC X(00080).

       FD  ALTKSD-FILE
           DATA RECORD    IS ALTKSD-REC
           .
       01  ALTKSD-REC.
           05  ALTKSD-KEY-01  PIC X(00012).
           05  ALTKSD-DATA-01 PIC X(00500).

      *****************************************************************
      * This program was created using the SYSMASK3.TXT file as the   *
      * template for the File I/O. It is intended for use with the    *
      * TransCALL facility that makes a call to a routine that does   *
      * the actual conversion between EBCDIC and ASCII. For more      *
      * information or questions contact SimoTime Technologies.       *
      *                                                               *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      * The SYSMASK3 provides for the sequential reading of the input *
      * file and the sequential writing of the output file.           *
      * If the output file is indexed then the input file must be in  *
      * sequence by the field that will be used to provide the key    *
      * for the output file.                                          *
      *                                                               *
      * If the key field is not in sequence then refer to SYSMASK4    *
      * to provide for a random add or update of the indexed file.    *
      *****************************************************************
       WORKING-STORAGE SECTION.
       01  SIM-TITLE.
           05  T1 pic X(11) value '* CBLALTC9 '.
           05  T2 pic X(34) value 'Data Migration and Conversion     '.
           05  T3 pic X(10) value 'v05.06.08 '.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* CBLALTC9 '.
           05  C2 pic X(20) value 'Created by SimoZAPS,'.
           05  C3 pic X(20) value '  a utility package '.
           05  C4 pic X(28) value 'of   SimoTime Technologies  '.

       01  ALTQSMD2-STATUS.
           05  ALTQSMD2-STATUS-L     pic X.
           05  ALTQSMD2-STATUS-R     pic X.
       01  ALTQSMD2-EOF              pic X       value 'N'.
       01  ALTQSMD2-OPEN-FLAG        pic X       value 'C'.

       01  ALTKSD-STATUS.
           05  ALTKSD-STATUS-L     pic X.
           05  ALTKSD-STATUS-R     pic X.
       01  ALTKSD-EOF              pic X       value 'N'.
       01  ALTKSD-OPEN-FLAG        pic X       value 'C'.

      *****************************************************************
      * The following buffers are used to create a four-byte status   *
      * code that may be displayed.                                   *
      *****************************************************************
       01  IO-STATUS.
           05  IO-STAT1            pic X.
           05  IO-STAT2            pic X.
       01  IO-STATUS-04.
           05  IO-STATUS-0401      pic 9     value 0.
           05  IO-STATUS-0403      pic 999   value 0.
       01  TWO-BYTES-BINARY        pic 9(4)  BINARY.
       01  TWO-BYTES-ALPHA         redefines TWO-BYTES-BINARY.
           05  TWO-BYTES-LEFT      pic X.
           05  TWO-BYTES-RIGHT     pic X.

      *****************************************************************
      * Message Buffer used by the Z-DISPLAY-MESSAGE-TEXT routine.    *
      *****************************************************************
       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(11)   value '* CBLALTC9 '.
           05  MESSAGE-TEXT.
               10  MESSAGE-TEXT-1  pic X(68)   value SPACES.
               10  MESSAGE-TEXT-2  pic X(188)  value SPACES.

      *****************************************************************
       01  PROGRAM-NAME            pic X(8)     value 'CBLALTC9'.

       01  APPL-RESULT             pic S9(9)    comp.
           88  APPL-AOK            value 0.
           88  APPL-EOF            value 16.

       01  ALTQSMD2-TOTAL.
           05  ALTQSMD2-RDR  pic 9(9)    value 0.
           05  filler      pic X(3)    value ' - '.
           05  filler      pic X(23)   value 'Line count for ALTQSMD2'.
       01  ALTKSD-TOTAL.
           05  ALTKSD-ADD  pic 9(9)    value 0.
           05  filler      pic X(3)    value ' - '.
           05  filler      pic X(23)   value 'Line count for ALTKSD  '.

      *****************************************************************
       PROCEDURE DIVISION.
           perform Z-POST-COPYRIGHT
           perform ALTQSMD2-OPEN
           perform ALTKSD-OPEN

           perform until ALTQSMD2-STATUS not = '00'
               perform ALTQSMD2-READ
               if  ALTQSMD2-STATUS = '00'
                   add 1 to ALTQSMD2-RDR
                   perform BUILD-OUTPUT-RECORD
                   perform ALTKSD-WRITE
                   if  ALTKSD-STATUS = '00'
                       add 1 to ALTKSD-ADD
                   end-if
               end-if
           end-perform

           move ALTQSMD2-TOTAL to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT

           move ALTKSD-TOTAL to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT

           if  APPL-EOF
               move 'is Complete...' to MESSAGE-TEXT
           else
               move 'is ABENDING...' to MESSAGE-TEXT
           end-if
           perform Z-DISPLAY-MESSAGE-TEXT

           perform ALTKSD-CLOSE
           perform ALTQSMD2-CLOSE
           GOBACK.

      *****************************************************************
       BUILD-OUTPUT-RECORD.
      *>   TransMODE is &&&...

      *>   TransCOPY...
           move ALTQSMD2-REC(00001:00080) to ALTKSD-REC(00001:00080)
           exit.

      *****************************************************************
      * I/O Routines for the INPUT File...                            *
      *****************************************************************
       ALTQSMD2-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close ALTQSMD2-FILE
           if  ALTQSMD2-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CLOSE Failure with ALTQSMD2' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move ALTQSMD2-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       ALTQSMD2-READ.
           read ALTQSMD2-FILE
           if  ALTQSMD2-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  ALTQSMD2-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if
           if  APPL-AOK
               CONTINUE
           else
               if  APPL-EOF
                   move 'Y' to ALTQSMD2-EOF
               else
                   move 'READ Failure with ALTQSMD2' to MESSAGE-TEXT
                   perform Z-DISPLAY-MESSAGE-TEXT
                   move ALTQSMD2-STATUS to IO-STATUS
                   perform Z-DISPLAY-IO-STATUS
                   perform Z-ABEND-PROGRAM
               end-if
           end-if
           exit.
      *---------------------------------------------------------------*
       ALTQSMD2-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open input ALTQSMD2-FILE
           if  ALTQSMD2-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to ALTQSMD2-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'OPEN Failure with ALTQSMD2' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move ALTQSMD2-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * I/O Routines for the OUTPUT File...                           *
      *****************************************************************
       ALTKSD-WRITE.
           if  ALTKSD-OPEN-FLAG = 'C'
               perform ALTKSD-OPEN
           end-if
           write ALTKSD-REC
           if  ALTKSD-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  ALTKSD-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if.
           if  APPL-AOK
               CONTINUE
           else
               move 'WRITE Failure with ALTKSD  ' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move ALTKSD-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       ALTKSD-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open OUTPUT ALTKSD-FILE
           if  ALTKSD-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to ALTKSD-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'OPEN Failure with ALTKSD  ' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move ALTKSD-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       ALTKSD-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close ALTKSD-FILE
           if  ALTKSD-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'C' to ALTKSD-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CLOSE Failure with ALTKSD  ' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move ALTKSD-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * The following Z-ROUTINES provide administrative functions     *
      * for this program.                                             *
      *****************************************************************
      * ABEND the program, post a message to the console and issue    *
      * a STOP RUN.                                                   *
      *****************************************************************
       Z-ABEND-PROGRAM.
           if  MESSAGE-TEXT not = SPACES
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           move 'PROGRAM-IS-ABENDING...'  to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT
           add 12 to ZERO giving RETURN-CODE
           STOP RUN.
      *    exit.

      *****************************************************************
      * Display CONSOLE messages...                                   *
      *****************************************************************
       Z-DISPLAY-MESSAGE-TEXT.
           if MESSAGE-TEXT-2 = SPACES
               display MESSAGE-BUFFER(1:79)
           else
               display MESSAGE-BUFFER
           end-if
           move all SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
      * Display the file status bytes. This routine will display as   *
      * four digits. If the full two byte file status is numeric it   *
      * will display as 00nn. If the 1st byte is a numeric nine (9)   *
      * the second byte will be treated as a binary number and will   *
      * display as 9nnn.                                              *
      *****************************************************************
       Z-DISPLAY-IO-STATUS.
           if  IO-STATUS not NUMERIC
           or  IO-STAT1 = '9'
               move IO-STAT1 to IO-STATUS-04(1:1)
               subtract TWO-BYTES-BINARY from TWO-BYTES-BINARY
               move IO-STAT2 to TWO-BYTES-RIGHT
               add TWO-BYTES-BINARY to ZERO giving IO-STATUS-0403
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STATUS-04 to MESSAGE-TEXT(17:4)
               perform Z-DISPLAY-MESSAGE-TEXT
           else
               move '0000' to IO-STATUS-04
               move IO-STATUS to IO-STATUS-04(3:2)
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STATUS-04 to MESSAGE-TEXT(17:4)
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           exit.

      *****************************************************************
       Z-POST-COPYRIGHT.
           display SIM-TITLE
           display SIM-COPYRIGHT
           exit.
      *****************************************************************
      *           This program was generated by SimoZAPS              *
      *             A product of SimoTime Technologies                *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      *  Generation Date: 2005-06-29  Generation Time: 22:51:28:18    *
      *****************************************************************
