@echo OFF
rem  * *******************************************************************
rem  *               CBLALTE8.CMD - a Windows Command File               *
rem  *         This program is provided by SimoTime Technologies         *
rem  *           (C) Copyright 1987-2019 All Rights Reserved             *
rem  *             Web Site URL:   http://www.simotime.com               *
rem  *                   e-mail:   helpdesk@simotime.com                 *
rem  * *******************************************************************
rem  *
rem  *  Text   - Create a Sequential Data Set on disk using IEBGENER.
rem  *  Author - SimoTime Technologies
rem  *  Date   - January 24, 1996
rem  *
rem  *  The first job step (DELALTS1) will delete any previously created
rem  *  file. The second job step (CRTQNAME) will create a new file. The
rem  *  third job step (SORTST03) will sort the file.
rem  *
rem  *  This set of programs will run on a mainframe under MVS or on a
rem  *  Personal Computer with Windows and Micro Focus Mainframe Express.
rem  *
rem  *                       ************
rem  *                       * CBLALTE8 *
rem  *                       ********cmd*
rem  *                            *
rem  *                            *
rem  *                       ************     ************
rem  *                       * if EXIST ******* ALTTXTD1 *
rem  *                       ********cmd*     ***delete***
rem  *                            *
rem  *                            *
rem  *      ************     ************     ************
rem  *      *  SYSIN   *******   echo   ******* ALTTXTD1 *
rem  *      ********cmd*     ********cmd*     ********txt*
rem  *                            *
rem  *                            *
rem  *      ************     ************     ************
rem  *      * ALTQSMD1 *******   SORT   ******* ALTQSMD2 *
rem  *      ********qsm*     ********utl*     ********qsm*
rem  *                            *
rem  *                            *
rem  *      ************     ************     ************
rem  *      *  SYSIN   *******   echo   ******* ALTTXTD3 *
rem  *      ********cmd*     ********cmd*     ********TXT*
rem  *                            *
rem  *                            *
rem  *                       ************
rem  *                       *   EOJ    *
rem  *                       ************
rem  *
rem  *
rem  * ********************************************************************
rem  * Step 1 of 7, Set the global environment variables...
rem  *
     call ..\Env1BASE %CmdName%
     if "%SYSLOG%" == "" set syslog=c:\SimoLIBR\LOGS\SimoTime.LOG
     set CmdName=CblAltE8
rem  *
     call SimoNOTE "*******************************************************%CmdName%"
     call SimoNOTE "Starting CmdName %CmdName%"
rem  *  *******************************************************************
rem  *  Step 2 of 7, Delete any previously created file...
rem  *
:CblAltSetClean
     call SimoNOTE "Identify JobStep CblAltSetClean, Set environment, Cleanup old files..."
     set ALTTXTD1=%BaseLib1%\DATA\Txt1\ALTTXTD1.TXT
     set ALTTXTD3=%BaseLib1%\DATA\Txt1\ALTTXTD3.TXT
     set ALTQSMD1=%BaseLib1%\DATA\Wrk1\ALTQSMD1.DAT
     set ALTQSMD2=%BaseLib1%\DATA\Wrk1\ALTQSMD2.DAT
     set ALTQSMD3=%BaseLib1%\DATA\Wrk1\ALTQSMD3.DAT
     if exist %ALTTXTD1% erase %ALTTXTD1%
     if exist %ALTTXTD3% erase %ALTTXTD3%
     if exist %ALTQSMD1% erase %ALTQSMD1%
     if exist %ALTQSMD2% erase %ALTQSMD2%
     if exist %ALTQSMD3% erase %ALTQSMD3%
rem  *
:CreateText1
rem  *  *******************************************************************
rem  *  Step 3 of 7, Create out-of-sequence QSAM file...
rem  *
rem  *  Number..Name, Last          First               Middle          Telephone
rem  * ...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
echo 000000000100Anderson            Adrian              A               123.456.7890> %ALTTXTD1%
echo 000000000200Brown               Billie              B               234.567.8901>> %ALTTXTD1%
echo 000000000300Carson              Cameron             C               345.678.9012>> %ALTTXTD1%
echo 000000002600Zenith              Zebulon             Z               890.123.4567>> %ALTTXTD1%
echo 000000000500Everest             Evan                E               567.890.1234>> %ALTTXTD1%
echo 000000000600Franklin            Francis             F               678.901.2345>> %ALTTXTD1%
echo 000000000700Garfunkel           Gwen                G               789.012.3456>> %ALTTXTD1%
echo 000000000800Harrison            Hilary              H               890.123.4567>> %ALTTXTD1%
echo 000000000900Isley               Isabel              I               901.234.5678>> %ALTTXTD1%
echo 000000001000Johnson             Jamie               J               123.456.7890>> %ALTTXTD1%
echo 000000001100Kemper              Kelly               K               234.567.8901>> %ALTTXTD1%
echo 000000001200Lemond              Lesley              L               345.678.9012>> %ALTTXTD1%
echo 000000001300Mitchell            Marlow              M               456.789.0123>> %ALTTXTD1%
echo 000000001400Newman              Noel                N               567.890.1234>> %ALTTXTD1%
echo 000000001500Osborn              Owen                O               678.901.2345>> %ALTTXTD1%
echo 000000001600Powell              Pierce              P               789.012.3456>> %ALTTXTD1%
echo 000000001700Quigley             Quincy              Q               890.123.4567>> %ALTTXTD1%
echo 000000000400Davidson            Dion                D               456.789.0123>> %ALTTXTD1%
echo 000000001800Ripley              Ray                 R               901.234.5678>> %ALTTXTD1%
echo 000000001900Smith               Sammy               S               123.456.7890>> %ALTTXTD1%
echo 000000002000Tucker              Taylor              T               234.567.8901>> %ALTTXTD1%
echo 000000002100Underwood           Ulysses             U               345.678.9012>> %ALTTXTD1%
echo 000000002200Victoria            Vaughn              V               456.789.0123>> %ALTTXTD1%
echo 000000002300Wilson              Wiley               W               567.890.1234>> %ALTTXTD1%
echo 000000002400Xray                Xavier              X               678.901.2345>> %ALTTXTD1%
echo 000000002500Young               Yanni               Y               789.012.3456>> %ALTTXTD1%
rem  *
:SortFile1
rem  *  *******************************************************************
rem  *  Step 4 of 7, Sort the file,
rem  *               Read Line Sequential write Record Sequential
rem  *
     call SimoNOTE "Identify JobStep SortFile1, Sort by Primary Key"
     set SYSIN=%BaseLib1%\ParmLib1\CBLALTT1.SRT
     set SORTIN=%ALTTXTD1%
     set SORTOUT=%ALTQSMD2%
     MFSORT SORT FIELDS=(1,12,CH,A) use %SORTIN% ORG LS give %SORTOUT% RECORD F,80 ORG SQ
     if not "%ERRORLEVEL%" == "0" set JobStatus=0030
     if not "%JobStatus%" == "0000" goto :EojNOK
     if exist %ALTQSMD2% call SimoNOTE "Produced DataSet %ALTQSMD2%"
     if exist %ALTQSMD2% goto :CreateText2
        call SimoNOTE "ABENDING JobStep SortFile1, Sort Failure..."
        goto :EojNOK
rem  *
:CreateText2
rem  *  *******************************************************************
rem  *  Step 5 of 7, Create 2nd QSAM file...
rem  *
rem  *  Number..Name, Last          First               Middle          Telephone
rem  * ...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
echo 000000987654SMITH               JANE                J               410.777.7000>  %ALTTXTD3%
echo 000000123456DOE                 JOHN                JAY             499.999.9000>> %ALTTXTD3%
     if exist %ALTTXTD3% call SimoNOTE "Produced DataSet %ALTTXTD3%"
rem  *
:ConvertLseqToRseq
rem  *  *******************************************************************
rem  *  Step 6 of 7, Convert Line Sequential to Record Sequential...
rem  *
     set GETLS080=%ALTTXTD3%
     set PUTRS080=%ALTQSMD3%
     run CV80ALAR
     if exist %ALTQSMD3% call SimoNOTE "Produced DataSet %ALTQSMD3%"
     if exist %ALTQSMD3% goto :EojAOK
        call SimoNOTE "ABENDING JobStep ConvertLseqToRseq, Conversion Failure..."
        goto :EojNOK
rem  *
rem  *  *******************************************************************
rem  *  Step 7 of 7, End-of-Job
rem  *
:EojAOK
     call SimoNOTE "Finished CmdName %CmdName%, Job Status is %JobStatus%"
     goto :End
:EojNOK
     call SimoNOTE "ABENDING CmdName %CmdName%, Job Status is %JobStatus%"
     echo %DATE% - %TIME% Starting User ABEND Processing...>>%SYSLOG%
     set >>%SYSLOG%
     echo %DATE% - %TIME% Complete User ABEND Processing...>>%SYSLOG%
     goto :End
:End
     call SimoNOTE "Conclude SysOut is %SYSOUT%"
     if not "%1" == "nopause" pause
     exit /B %JobStatus%

