//CBLALTJ8 JOB SIMOTIME,CLASS=1,MSGCLASS=0,NOTIFY=CSIP1
//* *******************************************************************
//*       CBLALTJ8.JCL - a JCL Member for Batch Job Processing        *
//*       This JCL Member is provided by SimoTime Technologies        *
//*           (C) Copyright 1987-2019 All Rights Reserved             *
//*             Web Site URL:   http://www.simotime.com               *
//*                   e-mail:   helpdesk@simotime.com                 *
//* *******************************************************************
//*
//* Text   - Create a Sequential Data Set on disk using IEBGENER.
//* Author - SimoTime Technologies
//* Date   - January 24, 1996
//*
//* The 1st job step will delete any previously created file.
//* The second job step (CRTQNAME) will create a new file.
//* The third job step (SORTST03) will sort the file.
//*
//* This set of programs will run on a mainframe under MVS or on a
//* Personal Computer with Windows and Micro Focus Mainframe Express.
//*
//*                      ************
//*                      * CBLALTJ8 *
//*                      ********jcl*
//*                           *
//*                           *
//*                      ************     ************
//*                      * IEFBR14  ******* ALTQSMD1 *
//*                      ********utl*     ***delete***
//*                           *
//*                           *
//*     ************     ************     ************
//*     *  SYSIN   ******* IEBGENER ******* ALTQSMD1 *
//*     ********jcl*     ********utl*     *******qsam*
//*                           *
//*                           *
//*     ************     ************     ************
//*     * ALTQSMD1 *******   SORT   ******* ALTQSMD2 *
//*     ********jcl*     ********utl*     *******qsam*
//*                           *
//*                           *
//*     ************     ************     ************
//*     *  SYSIN   ******* IEBGENER ******* ALTQSMD3 *
//*     ********jcl*     ********utl*     *******qsam*
//*                           *
//*                           *
//*                      ************
//*                      *   EOJ    *
//*                      ************
//*
//* *******************************************************************
//* Step 1 of 4, Delete any previously created file...
//*
//CLEANUP1 EXEC PGM=IEFBR14
//ALTQSMD1 DD  DSN=SIMOTIME.DATA.ALTQSMD1,DISP=(MOD,DELETE,DELETE),
//             STORCLAS=MFI,
//             SPACE=(TRK,5),
//             DCB=(RECFM=FB,LRECL=80,BLKSIZE=800,DSORG=PS)
//ALTQSMD2 DD  DSN=SIMOTIME.DATA.ALTQSMD2,DISP=(MOD,DELETE,DELETE),
//             STORCLAS=MFI,
//             SPACE=(TRK,5),
//             DCB=(RECFM=FB,LRECL=80,BLKSIZE=8000,DSORG=PS)
//ALTQSMD3 DD  DSN=SIMOTIME.DATA.ALTQSMD3,DISP=(MOD,DELETE,DELETE),
//             STORCLAS=MFI,
//             SPACE=(TRK,5),
//             DCB=(RECFM=FB,LRECL=80,BLKSIZE=8000,DSORG=PS)
//*
//* *******************************************************************
//* Step 2 of 4, Create and populate a new QSAM file...
//*
//QSAMCRT1 EXEC PGM=IEBGENER
//SYSPRINT DD  SYSOUT=*
//SYSIN    DD  DUMMY
//* Number..Name, Last          First               Middle          Telephone
//* :....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
//SYSUT1   DD  *
000000000100Anderson            Adrian              A               123.456.7890
000000000200Brown               Billie              B               234.567.8901
000000000300Carson              Cameron             C               345.678.9012
000000002600Zenith              Zebulon             Z               890.123.4567
000000000500Everest             Evan                E               567.890.1234
000000000600Franklin            Francis             F               678.901.2345
000000000700Garfunkel           Gwen                G               789.012.3456
000000000800Harrison            Hilary              H               890.123.4567
000000000900Isley               Isabel              I               901.234.5678
000000001000Johnson             Jamie               J               123.456.7890
000000001100Kemper              Kelly               K               234.567.8901
000000001200Lemond              Lesley              L               345.678.9012
000000001300Mitchell            Marlow              M               456.789.0123
000000001400Newman              Noel                N               567.890.1234
000000001500Osborn              Owen                O               678.901.2345
000000001600Powell              Pierce              P               789.012.3456
000000001700Quigley             Quincy              Q               890.123.4567
000000000400Davidson            Dion                D               456.789.0123
000000001800Ripley              Ray                 R               901.234.5678
000000001900Smith               Sammy               S               123.456.7890
000000002000Tucker              Taylor              T               234.567.8901
000000002100Underwood           Ulysses             U               345.678.9012
000000002200Victoria            Vaughn              V               456.789.0123
000000002300Wilson              Wiley               W               567.890.1234
000000002400Xray                Xavier              X               678.901.2345
000000002500Young               Yanni               Y               789.012.3456
/*
//SYSUT2   DD  DSN=SIMOTIME.DATA.ALTQSMD1,
//             DISP=(NEW,CATLG,DELETE),
//             STORCLAS=MFI,
//             SPACE=(TRK,5),
//             DCB=(RECFM=FB,LRECL=80,BLKSIZE=800,DSORG=PS)
//*
//* *******************************************************************
//* Step 3 of 4, Sort by customer number (positions 1-12)...
//* *******************************************************************
//*
//SORTST03 EXEC PGM=SORT,
//             REGION=1024K,
//             PARM='CORE=500K,RELEASE=OFF'
//SYSIN    DD  DSN=SIMOTIME.PDS.PARMLIB(CBLALTT1),DISP=SHR
//SORTWK01 DD  UNIT=SYSDA,SPACE=(CYL,55)
//SORTWK02 DD  UNIT=SYSDA,SPACE=(CYL,55)
//SORTWK03 DD  UNIT=SYSDA,SPACE=(CYL,55)
//SORTIN   DD  DSN=SIMOTIME.DATA.ALTQSMD1,DISP=SHR
//SORTOUT  DD  DSN=SIMOTIME.DATA.ALTQSMD2,DISP=(NEW,CATLG,DELETE),
//             STORCLAS=MFI,
//             SPACE=(TRK,5),
//             DCB=(RECFM=FB,LRECL=80,BLKSIZE=8000,DSORG=PS)
//SYSOUT   DD  SYSOUT=*
//*
//* *******************************************************************
//* Step 4 of 4, Create and populate a new QSAM file...
//*
//QSAMCRT3 EXEC PGM=IEBGENER
//SYSPRINT DD  SYSOUT=*
//SYSIN    DD  DUMMY
//* NUMBER..NAME, LAST          FIRST               MIDDLE          TELEPHONE
//* :....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
//SYSUT1   DD  *
000000987654SMITH               JANE                J               444.432.8765
000000123456DOE                 JOHN                JAY             901.234.5678
/*
//SYSUT2   DD  DSN=SIMOTIME.DATA.ALTQSMD3,
//             DISP=(NEW,CATLG,DELETE),
//             STORCLAS=MFI,
//             SPACE=(TRK,5),
//             DCB=(RECFM=FB,LRECL=80,BLKSIZE=800,DSORG=PS)
//*
